<div class="container">
  <form [formGroup]="addShipmentForm" (ngSubmit)="onSubmit()">
    <!-- RECEIVER NAME FIELD -->
    <!-- Structure the form using bootstrap form-group class -->
    <fieldset class="mb-3 form-group">
      <!--bootstrap class form-label-->
      <label class="form-label" for="receiver-name">Receiver Name: </label>
      <!--bootstrap class form-control-->
      <!--basic form validation-->
      <!--see global CSS for red/green input validity indicator-->
      <input
        id="receiver-name"
        formControlName="receiver_name"
        type="text"
        class="form-control"
      />

      <!--structural directive *ngIf allows us to check for validations-->
      <ul
        *ngIf="
          receiverName!.invalid &&
          (receiverName!.dirty || receiverName!.touched)
        "
      >
        <!-- list of errors -->
        <li *ngIf="receiverName!.errors?.required" class="text-danger small">
          Name is required
        </li>
        <li *ngIf="receiverName!.errors?.minlength" class="text-danger small">
          Name must be at least 2 characters long
        </li>
        <li *ngIf="receiverName!.errors?.maxlength" class="text-danger small">
          Name exceeds maximum allowed length
        </li>
        <li *ngIf="receiverName!.errors?.pattern" class="text-danger small">
          Name cannot contain numbers or symbols
        </li>
      </ul>
    </fieldset>

    <!--WEIGHT FIELD -->
    <fieldset class="mb-3 form-group">
      <label class="form-label" for="weight">Weight: </label>
      <select id="weight" formControlName="weight" class="form-control">
        <option value="1">basic - 1kg</option>
        <option value="2" selected>humble - 2kg</option>
        <option value="5">deluxe - 5kg</option>
        <option value="8">premium - 8kg</option>
      </select>
      <!--structural directive *ngIf allows us to check for validations-->
      <!-- list of errors -->
      <ul *ngIf="weight!.invalid && (weight!.dirty || weight!.touched)">
        <li *ngIf="weight!.errors?.required" class="text-danger small">
          Weight is required
        </li>
      </ul>
    </fieldset>

    <!-- BOX COLOUR FIELD -->
    <fieldset class="mb-3 form-group">
      <!--bootstrap class form-label-->
      <label class="form-label" for="box-colour">Box Colour: </label>

      <input
        id="box-colour"
        formControlName="box_colour"
        class="form-control"
        (colorPickerChange)="onChangeColor($event)"
        [(colorPicker)]="boxColourValue"
        [style.background]="boxColourValue"
      />
      <!--structural directive *ngIf allows us to check for validations-->
      <!-- list of errors -->
      <ul
        *ngIf="boxColour!.invalid && (boxColour!.dirty || boxColour!.touched)"
      >
        <li *ngIf="boxColour!.errors?.required" class="text-danger small">
          Colour is required
        </li>
        <li *ngIf="boxColour!.errors?.maxalpha" class="text-danger small">
          Alpha must be between 0 and 1
        </li>
        <li *ngIf="boxColour!.errors?.maxrgb" class="text-danger small">
          RGB values must be between 0 and 255
        </li>
        <li *ngIf="boxColour!.errors?.maxlength" class="text-danger small">
          Exceeded maximum input length for colour value
        </li>
        <li *ngIf="boxColour!.errors?.invalid" class="text-danger small">
          Invalid colour value
        </li>
      </ul>
    </fieldset>

    <!--DESTINATION COUNTRY FIELD -->
    <fieldset class="mb-3 form-group">
      <label class="form-label" for="country">Destination Country: </label>
      <select
        id="destination-country"
        formControlName="destination_id"
        class="form-control"
      >
        <option *ngFor="let item of countries" [ngValue]="item.id">
          {{ item.country_name }}
        </option>
      </select>
      <!--structural directive *ngIf allows us to check for validations-->
      <!-- list of errors -->
      <ul
        *ngIf="
          destinationCountry!.invalid &&
          (destinationCountry!.dirty || destinationCountry!.touched)
        "
      >
        <li
          *ngIf="destinationCountry!.errors?.required"
          class="text-danger small"
        >
          Destination country is required
        </li>
      </ul>
    </fieldset>

    <!-- DISPLAY THE COST IN NORWEGIAN CURRENCY-->
    <fieldset>
      <p *ngIf="destinationCountry!.value && weight!.value">
        <!-- Price from form getter  -->
        Price = {{ calcPrice }} NOK (incl. shipping fees)
      </p>
    </fieldset>

    <!-- CANCEL BUTTON -->
    <button
      (click)="resetAndCloseDialog()"
      type="button"
      mat-raised-button
      color="basic"
    >
      Cancel
    </button>

    <!-- small space -->
    &nbsp;

    <!-- SUBMIT BUTTON -->
    <button
      mat-raised-button
      color="accent"
      type="submit"
      [disabled]="!addShipmentForm.valid"
    >
      Buy
    </button>
  </form>
</div>
